unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Unit2, ActnList, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ActionList1: TActionList;
    Image1: TImage;
    Label3: TLabel;
    Label0: TLabel;
    PopupMenu1: TPopupMenu;
    Modifier: TMenuItem;
    nombre: TMenuItem;
    Genre: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    mnuadj: TMenuItem;
    mnunom: TMenuItem;
    mnuGN: TMenuItem;
    mnuprep: TMenuItem;
    mnudet: TMenuItem;
    N3: TMenuItem;
    ajAdj: TMenuItem;
    ajAdv: TMenuItem;
    ppTemps: TMenuItem;
    Mode: TMenuItem;
    Inserer1: TMenuItem;
    Ajouter1: TMenuItem;
    ajNom: TMenuItem;
    ajDet: TMenuItem;
    ajPrep: TMenuItem;
    ajcomp: TMenuItem;
    ajPnom: TMenuItem;
    ajverbe: TMenuItem;
    ajGN: TMenuItem;
    Edit1: TEdit;
    MainMenu1: TMainMenu;
    Fichier: TMenuItem;
    nxmot: TMenuItem;
    NxAdj: TMenuItem;
    NxAdv: TMenuItem;
    NxDet: TMenuItem;
    NxGN: TMenuItem;
    NxNom: TMenuItem;
    NxPrep: TMenuItem;
    NxPnom: TMenuItem;
    NxVerbe: TMenuItem;
    NxDeg: TMenuItem;
    Charger1: TMenuItem;
    Sauver1: TMenuItem;
    Ajouter2: TMenuItem;
    Quitter1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure GenreClick(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure ModifierClick(Sender: TObject);
    procedure nombreClick(Sender: TObject);
    procedure NxAdjClick(Sender: TObject);
    procedure NxAdvClick(Sender: TObject);
    procedure NxDegClick(Sender: TObject);
    procedure NxDetClick(Sender: TObject);
    procedure NxGNClick(Sender: TObject);
    procedure NxNomClick(Sender: TObject);
    procedure NxPrepClick(Sender: TObject);
    procedure NxVerbeClick(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ModeClick(Sender: TObject);
    procedure ppTempsClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Exit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  Tzone= record
           x1,y1,x2,y2:word;
           typ:integer;
           mot:integer;
           text:string;
           color:Tcolor;
           cursor:Tcursor;
           enabled:boolean;
           index:word;
           infos:string;
         end;

var
  Form1: TForm1;
  temps:array of string;
  maxtps:word;
  exps:array of PTexp;
  pos:array of Tzone;
  tour,mine:Integer;
  style:Tpenstyle;
  mot1,mot2:integer;         { mot1 avec picture1 mot2=nomot }
  droit:boolean;          { indique si le bouton droit est enfonc (picture1) }
  saisie:boolean;  { indique  Edit1 si le mot est en train d'tre modifi }
{ dessin du trait de liaison entre deux mots : }
  xo,yo:Integer;  { position de la souris }
  hors:boolean;  { indique si la souris est hors du mot initial }
  xm,ym:Integer;   { centre du mot initial }
  modif:boolean;   { indique si le mot est en train d'tre modifi }
{ !!!! duplication avec saisie ???? }
  enaction:boolean;     { vite la redondance lors du chgmt de Edit1 }

procedure aff_mot(no:Integer);

implementation

{$R *.DFM}

var
  nbex:word;

procedure init_niveaux;    {!! inutilis ou inutile }
  {fixe le milieu de la reprsentation en cercles et le rayon
  'des diffrents cercles}
  begin
    If nbmot=0 Then
      begin
        xm:=form1.Image1.Width div 2;
        ym:=form1.Image1.Height div 2;
        lg[0]:=0;
        lg[1]:=0;
        lg[2]:=0;
      end
  end;

function quellezone(x,y:Single):Integer;    { utilis par image1mousedown/move/up }
  var
    i:Integer;
    dans:boolean;

  begin
    dans:=false;
    i:=0;
    While not(dans) And (i<nbmot) do
      begin
        If (pos[i].x2>=x) And (x>=pos[i].x1) Then
          If (y<=pos[i].y2) And (y>=pos[i].y1) Then
          { dedans }
            If pos[i].typ=cGN Then
              begin
              If (pos[i].x2-2<=x) Or (x<=pos[i].x1+2) Then
                begin
                  dans:=true;
                  i:=i-1;
                end
              Else
                If (y>=pos[i].y2-2) Or (y<=pos[i].y1+2) Then
                  begin
                    dans:=true;
                    i:=i-1;
                  end
              end
            Else  { normal }
              begin
                dans:=true;
                i:=i-1;
              end;
        i:=i+1;
      end;
    If i<>nbmot Then
    { form1.Picture1.Print i }
      quellezone:=i
    Else
      quellezone:=aucun;
  end;

procedure aff_lien(mot1,mot2:Integer); { utilis par reaffiche }
  var                                  { en fait, non encore utilis }
    xm1,ym1:Integer;
    xm2,ym2:Integer;
         { trs mauvaise gestion des liens !!!! }
  begin
    with pos[mot1] do
      begin
        xm1:=(x1+x2) div 2;
        ym1:=(y1+y2) div 2;
      end;
    with pos[mot2] do
      begin
        xm2:=(x1+x2) div 2;
        ym2:=(y1+y2) div 2;
      end;
  { choisir la couleur du mot maitre }
    form1.Image1.Canvas.pen.Color:=clblack;
    form1.Image1.Canvas.MoveTo(xm1,ym1);
    form1.Image1.Canvas.LineTo(xm2,ym2);
  end;

Function singulier(mot:Integer):boolean; { par affiche_menu }
  var
    rep:boolean;

  begin
    Case pos[mot].typ of
      cnom:rep:=nom[pos[mot].mot].nombre;       { simplifier avec array of ? }
      cadj:rep:=adj[pos[mot].mot].nombre;
      cdet:rep:=det[pos[mot].mot].nombre;
    end;
    singulier:=rep;
  end;

procedure aff_menu(mot,x,y:Integer);   { par image1.mouseup }
  var
    Visibles:cardinal;

{ menu insrer : supprimer si vide ? sparer de ajouter par une ligne ? }
  begin
    If mot<>aucun Then
      Case pos[mot].typ of
        cverbe:begin
                 Visibles:=cmodifier;   { modifier }
                 Visibles:=Visibles+cgenre+cnombre; { genre et nombre }
                 Visibles:=Visibles+ctemps+cmode;  { temps et mode }
                 Visibles:=Visibles+cajgn+cajadj+cajdet+cajadv+cajnom+cajprep;
                 form1.nombre.Checked:=false;
                 form1.nombre.caption:='Personne';
               end;
        cnom,cdet,cadj:begin
                 Visibles:=cmodifier;   { modifier }
                 Visibles:=Visibles+cgenre+cnombre; { 'genre et nombre }
                 Visibles:=Visibles+cmnnom+cmndet+cmnadj+cmnprep; { ajout interne }
                 Visibles:=Visibles+cajverbe+cajgn+cajadj+cajdet+cajnom+cajprep;
        { GN, interne ou externe, mme si cpt du nom ? }
                 form1.nombre.Checked:=singulier(mot);
                 form1.nombre.caption:='Singulier';
               end;
        cdeg:begin
                 Visibles:=0;   { modifier }
                 Visibles:=Visibles+cnombre;  { ajout interne }
                 Visibles:=Visibles+cmnnom+cmnadj;   { ajout interne }
                 form1.nombre.Checked:=false;
                 form1.nombre.caption:='Degr';
             end;
        cadv:begin
                 Visibles:=cmodifier;   { modifier }
                 Visibles:=Visibles+cmnadj;  { ajout interne }
                 Visibles:=Visibles+cajverbe+cajadv;
             end;
        { ajout d'adverbe en interne plutt }
        cgn:begin
              Visibles:=0;   { modifier }
              { visible:=visible+cgenre+cnombre; }
              Visibles:=Visibles+cmndet+cmnnom+cmnprep+cmnadj; { ajout interne }
              Visibles:=Visibles+cajgn+cajverbe+cajnom+cajdet+cajadj+cajprep+cajcomp;
        { comparatif devrait tre dans interne }
              form1.nombre.Checked:=singulier(mot);
              form1.nombre.caption:='Singulier';
            end;
        cprep:begin
                Visibles:=cmodifier;   { modifier }
                Visibles:=Visibles+cmngn+cmndet+cmnnom+cmnadj;  { ajout interne }
                Visibles:=Visibles+cajgn+cajverbe+cajnom+cajdet+cajadj+cajcomp;
              end;
      end
    Else { fond }
      Visibles:=cajgn+cajverbe+cajnom+cajdet+cajadj+cajcomp+cajprep+cajadv;
    with form1 do
      begin
        Modifier.Visible:=(Visibles And cmodifier)=cmodifier;
        n1.visible:=Modifier.Visible;
        Genre.Visible:=(Visibles And cgenre)=cgenre;
        nombre.Visible:=(Visibles And cnombre)=cnombre;
        pptemps.Visible:=(Visibles And ctemps)=ctemps;
        If (Visibles And cmode)<>0 Then
          mode.Visible:=True
        Else
          mode.Visible:=False;
        n2.visible:=genre.visible or nombre.visible or pptemps.visible;
        n2.visible:=n2.visible or mode.visible;
        mnuadj.Visible:=(Visibles And cmnadj)=cmnadj;
        mnunom.Visible:=(Visibles And cmnnom)=cmnnom;
        mnudet.Visible:=(Visibles And cmndet)=cmndet;
        mnuGN.Visible:=(Visibles And cmngn)=cmngn;
        mnuprep.Visible:=(Visibles And cmnprep)=cmnprep;
        n3.Visible:=mnuadj.visible or mnunom.visible or mnudet.visible;
        n3.Visible:=n3.Visible or mnuGN.visible or mnuprep.visible;
        ajnom.Visible:=(Visibles And cajnom)=cajnom;
        ajdet.Visible:=(Visibles And cajdet)=cajdet;
        ajadj.Visible:=(Visibles And cajadj)=cajadj;
        ajadv.Visible:=(Visibles And cajadv)=cajadv;
        ajprep.Visible:=(Visibles And cajprep)=cajprep;
        ajverbe.Visible:=(Visibles And cajverbe)=cajverbe;
        ajcomp.Visible:=(Visibles And cajcomp)=cajcomp;
        ajgn.Visible:=(Visibles And cajgn)=cajgn;
        popupmenu1.popup(x,y);
      end;
  end;

procedure aff_mot(no:Integer);
  begin
    with form1 do
      begin
        Label0.Caption:=phrase[no].mot;
        phrase[no].l:=Label0.Width;
        phrase[no].h:=Label0.Height;
        pos[no].x2:=pos[no].x1+phrase[no].l+2;
        pos[no].y2:=pos[no].y1+phrase[no].h+2;
        image1.canvas.pen.width:=mine;
        image1.canvas.pen.Style:=pssolid;
        Image1.Canvas.Brush.Style:=bssolid;
        Image1.Canvas.Brush.Color:=clwhite;
      end;
    Case pos[no].typ of
      cnom:tour:=clblue; { nom, prep, det et adj dpendent de la fonction du GN }
      cverbe:tour:=clred;
      cdet:tour:=clblue;
      cadj:tour:=clblue;
      cadv:tour:=clfuchsia;    { tait ? }
      cprep:tour:=clblue;
      cdeg:tour:=claqua;      { tait fuchsia }
    end;
    Case pos[no].typ of
      cnom,cverbe,cdet,cadj,cadv:
        with pos[no] do
          rectangle((x2+x1) div 2,(y2+y1) div 2,x2-x1,y2-y1,false,mine,tour);
      cprep,cdeg:
        with pos[no] do
          ellipse((x2+x1) div 2,(y2+y1) div 2+1,x2-x1+8,y2-y1+7,1,tour);
    end;
    form1.image1.canvas.textout(pos[no].x1+1,pos[no].y1+1,phrase[no].mot);
    form1.Image1.Canvas.Brush.Style:=bsclear;
  end;

procedure eff_mot(no:Integer);              { utile ? imagemove ?}
  begin
    with form1 do
      begin
        image1.canvas.pen.width:=mine;
        image1.canvas.pen.Style:=pssolid;
        image1.canvas.pen.Mode:=pmnot;
        Image1.Canvas.Brush.Style:=bssolid;
        Image1.Canvas.Brush.Color:=clwhite;
      end;
    Case pos[no].typ of
      cnom,cverbe,cdet,cadj,cadv:
        with pos[no] do
          rectangle((x2+x1) div 2,(y2+y1) div 2,x2-x1,y2-y1,false,1,tour);
      cprep,cdeg:
        with pos[no] do
          ellipse((x2+x1) div 2,(y2+y1) div 2,x2-x1,y2-y1,1,tour);
    end;
    form1.Image1.Canvas.Brush.Style:=bsclear;
  end;

procedure aff_phrase;  { sur appel de label3 }
  var
    i:Integer;
    chgenre:array[0..3] of String;
    chnb:array[false..true] of String;
    chmod:array[0..6] of String;
    s:String;

  begin
    chgenre[0]:='?';
    chgenre[1]:='f';
    chgenre[2]:='m';
    chgenre[3]:='n';
    chnb[true]:='s';  { singulier si vrai ? }
    chnb[false]:='p';
    chmod[0]:='?';
    chmod[1]:='ind';
    chmod[2]:='cond';
    chmod[3]:='sub';
    chmod[4]:='imp';
    chmod[5]:='inf';
    chmod[6]:='part';
    form1.label3.Caption:='phrase :';
    For i:=0 To nbmot-1 do
      begin
        s:=phrase[i].mot;
        Case pos[i].typ of
          cnom:begin
                 s:=s+'('+chgenre[nom[pos[i].mot].genre]+'/';
                 s:=s+chnb[nom[pos[i].mot].nombre]+')'
               end;
          cadj:begin
                 s:=s+'('+chgenre[adj[pos[i].mot].genre]+'/';
                 s:=s+chnb[adj[pos[i].mot].nombre]+')'
                end;
          cdet:begin
                 s:=s+'('+chgenre[det[pos[i].mot].genre]+'/';
                 s:=s+chnb[det[pos[i].mot].nombre]+')';
               end;
          cverbe:begin
                   s:=s+'('+chmod[verbe[pos[i].mot].mode]+'/';
                   Case verbe[pos[i].mot].temps of
                     cindef:s:=s+'?)';
                     cpresent:s:=s+'pr)';
                     cpasse:s:=s+'pas)';
                     cimparfait:s:=s+'imp)';
                     cpqp: s:=s+'pqp)';
                     cfutur:s:=s+'fut)';
                     cfutant:s:=s+'fant)';
                     cpasant:s:=s+'pant)';
                     cpascomp:s:=s+'pc)';
                     cpasse2:s:=s+'pas2)';
                   end;
                 end;
          end;
          form1.label3.Caption:=form1.label3.Caption+' '+s;
      end;
  end;

procedure change_posGN(no,dx,dy:Integer);  { par change_pos }
{ par change_pos }
  var
    nb:Integer;

  begin             { pb lors du dplacement }
    nb:=GN[no].mot;
    with pos[nb] do
      begin
        x1:=x1+dx;
        y1:=y1+dy;
        x2:=x2+dx;
        y2:=y2+dy;
      end;
    If GN[no].noyau<>aucun Then { noyau suppos tre un nom (lien) }
      begin
        nb:=nom[GN[no].noyau].mot;  { noyau=lien car utilis comme indice }
        with pos[nb] do
          begin
            x1:=x1+dx;
            y1:=y1+dy;
            x2:=x2+dx;
            y2:=y2+dy;
          end;
        aff_mot(nb);
      end;
    If GN[no].det<>aucun Then
      begin
        nb:=det[GN[no].det].mot ;
        with pos[nb] do
          begin
            x1:=x1+dx;
            y1:=y1+dy;
            x2:=x2+dx;
            y2:=y2+dy;
          end;
        aff_mot(nb);
      end;
    If GN[no].adj<>aucun Then
      begin
        nb:=adj[GN[no].adj].mot;
        with pos[nb] do
          begin
            x1:=x1+dx;
            y1:=y1+dy;
            x2:=x2+dx;
            y2:=y2+dy;
          end;
        aff_mot(nb);
      end;
    nb:=GN[no].mot;
    with pos[nb] do
      begin
        rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
        rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-2,y2-y1-2,false,1,clblue);
      end;
  end;

procedure reaffiche;  { aprs un chgmt de position }
  var
    i,nmot:Integer;

  begin
    with form1.Image1 do
      begin
        Canvas.Brush.Style:=bssolid;
        Canvas.Brush.Color:=clwhite;
        Canvas.Pen.Style:=pssolid;
        Canvas.Pen.Color:=clwhite;
        canvas.Rectangle(0,0,Width,Height);
      end;
    For i:=0 To nbmot-1 do
      with pos[i] do
        Case typ of
          cverbe:with verbe[mot] do
                   begin
                     If sujet<>aucun Then
                       begin
                         nmot:=GN[sujet].mot;
                         aff_lien(i,nmot);
                       end;
                     If cpt<>aucun Then
                       begin
                         nmot:=GN[cpt].mot;
                         aff_lien(i,nmot);
                       end;
                   end;
          cnom:begin
                 If nom[mot].det<>aucun Then
                   begin
                     nmot:=det[nom[mot].det].mot;
                     aff_lien(i,nmot);
                   end;
                   If nom[mot].adj<>aucun Then
                     begin
                       nmot:=adj[nom[mot].adj].mot;
                       aff_lien(i,nmot);
                     end;
                   If nom[mot].cpt<>aucun Then
                     begin
                       nmot:=GN[nom[mot].cpt].mot;
                       aff_lien(i,nmot);
                     end;
                 end;
          cadj:begin
                 If adj[mot].cpl<>aucun Then
                   begin
                     nmot:=GN[adj[mot].cpl].mot;
                     aff_lien(i,nmot);
                   end;
                 If adj[mot].nom<>aucun Then
                   begin
                     nmot:=nom[adj[mot].nom].mot;
                     aff_lien(i,nmot);
                   end;
                 If adj[mot].degre<>aucun Then
                   begin
                     nmot:=deg[adj[mot].degre].mot;
                     aff_lien(i,nmot);
                   end;
               end;
          cdet:If det[mot].nom<>aucun Then
                 begin
                   nmot:=nom[det[mot].nom].mot;
                   aff_lien(i,nmot);
                 end;
      {il devrait aussi y avoir un autre lien sur art (cardinal) }
          cdeg:If deg[mot].adj<>aucun Then
                 begin
                   nmot:=adj[deg[mot].adj].mot;
                   aff_lien(i,nmot);
                 end;
      {rajouter le lien sur le comparant : peut tre mot ou adj
      'Case cadv:
      ' implmenter}
          cprep:with prep[mot] do
                  begin
                    If des<>aucun Then
                      begin
                        nmot:=nom[des].mot;
                        aff_lien(i,nmot);
                      end;
                    If lie<>aucun Then
                      begin
                        nmot:=nom[lie].mot;
                        aff_lien(i,nmot);
                      end;
                  end;
        end;
    For i:=0 To nbmot-1 do
      If pos[i].typ<>cgn Then
        aff_mot(i)
      else
        begin    { pb si GN cr aprs son noyau }
          with pos[i], form1.image1.canvas do
            begin
              pen.width:=2;
              pen.color:=clblue;
              pen.Style:=pssolid;
              Brush.Style:=bssolid;  { ou solid si affich avant son contenu }
              Brush.Color:=clwhite;
              rectangle(x1,y1,x2,y2);
            end;
        end;
    form1.Image1.Canvas.Brush.Style:=bsclear;
    form1.Image1.Canvas.Brush.Color:=clwhite;
  end;

procedure change_pos(mot:Integer);      { par image1mouseup }
  var
    dx,dy:Integer;
    non:boolean;

  begin
    with form1.Image1 do
      begin
        Canvas.pen.Style:=pssolid;
        Canvas.pen.Mode:=pmcopy; {celui-ci ? }
        Canvas.pen.Width:=1;
      end;
    dx:=pos[nbmot].x1-pos[mot].x1;
    dy:=pos[nbmot].y1-pos[mot].y1;
    non:=False;
    Case pos[mot].typ of
      cnom:If nom[pos[mot].mot].GN<>aucun Then
             change_posGN(nom[pos[mot].mot].GN,dx,dy)
           Else
             non:=True;
      cadj:If adj[pos[mot].mot].GN<>aucun Then
             change_posGN(adj[pos[mot].mot].GN,dx,dy)
           Else
             non:=True;
      cdet:If det[pos[mot].mot].nom<>aucun Then
             If nom[det[pos[mot].mot].nom].GN<>aucun Then
               change_posGN(nom[det[pos[mot].mot].nom].GN,dx,dy)
             Else
               non:=True
           Else
             non:=True;
      cgn:change_posGN(pos[mot].mot,dx,dy);
      Else
        with pos[mot] do
          begin
            x1:=pos[nbmot].x1;
            y1:=pos[nbmot].y1;
            x2:=pos[nbmot].x2;
            y2:=pos[nbmot].y2;
          end;
      end;
    If non Then
      with pos[mot] do
        begin
          x1:=pos[nbmot].x1;
          y1:=pos[nbmot].y1;
          x2:=pos[nbmot].x2;
          y2:=pos[nbmot].y2;
        end;
    reaffiche;
  end;

procedure initvar;                    { dans form.load : ncessaire }
  begin
    nbGN:=0;
    nbnom:=0;
    nbsujet:=0;
    nbverbe:=0;
    nbmot:=0;
    nbdet:=0;
    nbadj:=0;
    nbdeg:=0;
    nbprep:=0;
    {fond:=15;}               { " sauf fond }
  end;

procedure TForm1.FormCreate(Sender: TObject);
  begin
    with label3 do
      begin
        Caption:='Traduction :'+Chr(13)+'Bientt';
        Caption:=Caption+Chr(13)+' Ce cadre contiendra';
        Caption:=Caption+Chr(13)+' la phrase crite en franais.';
      end;
    enaction:=False;
    init_niveaux;
    initvar;
    mot1:=aucun;
    modif:=False;
    setlength(sujet,nbsujet+1);
    setlength(GN,nbGN+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    setlength(verbe,nbverbe+1);
    setlength(det,nbdet+1);
    setlength(nom,nbnom+1);
    setlength(adj,nbadj+1);
    setlength(deg,nbdeg+1);
    setlength(adv,nbadv+1);
    setlength(prep,nbprep+1);
  end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
  var
    i:integer;

  begin
    { librer les variables et tableaux dynamiques }
    maxtps:=0;
  { ce qui suit est obsolte }
    setlength(temps,maxtps);
    for i:=0 to nbex-1 do
      begin
        dispose(exps[i]);
      end;
    nbex:=0;
    setlength(exps,nbex);
    setlength(sujet,0);
    setlength(GN,0);
    setlength(phrase,0);
    setlength(pos,0);
    setlength(verbe,0);
    setlength(det,0);
    setlength(nom,0);
    setlength(adj,0);
    setlength(deg,0);
    setlength(adv,0);
    setlength(prep,0);
  end;

procedure TForm1.GenreClick(Sender: TObject);     { ok }
  begin
    nomot:=mot2;
    boite_genre(pos[nomot].mot,pos[nomot].typ);
  end;

procedure TForm1.Label3Click(Sender: TObject);    { ok }
  begin
    aff_phrase;
  end;

procedure lierGN_nom(mot1,mot2:Integer);   { inutilis }
  var
    ng,nn,i:Integer;

  begin
    ng:=pos[mot1].mot;
    nn:=pos[mot2].mot;
    If nom[nn].GN=aucun Then  { nom non li }
      begin
        nom[nn].GN:=ng;          { tenir compte des verbes aussi }
        with GN[ng] do
          begin
            If mot=aucun Then
              begin
                mot:=nn;
                noyau:=pos[mot2].typ;
              end
            else
              begin
                i:=mot;
                While nom[i].suite<>aucun do
                  i:=nom[i].suite;
                mot:=i;
              end;
  { les catgories suivantes dpendent de si le mot est un nom ou un verbe }
            If det=aucun Then
              det:=nom[nn].det;
            If adj=aucun Then
              adj:=nom[nn].adj;
            If cpt=aucun Then
              cpt:=nom[nn].cpt;
          end;
  { le GN n'a ni genre, ni nombre : les ajouter ? }
    {Select Case nom(nn).nombre
    '  Case cindef
    '    If GN(ng).nombre = sing Then   'heuu !?
    '      nom(nn).nombre = sing        'sing+sing = pluriel
    '    End If
    '  Case pluriel: GN(ng).nombre = pluriel
    '  Case sing:
    '    If GN(ng).nombre = cindef Then
    '      GN(ng).nombre = sing
    '    End If
    '    If GN(ng).nombre = sing Then    'dpend si GN est dj li au pas
    '      GN(ng).nombre = pluriel       'empcher la saisie ds GN tq non li  un nom ?
    '    End If
    'End Select
    'Select Case nom(nn).genre       'mmes problmes
    '  Case cindef
    '    If GN(ng).genre = fem Then
    '      nom(nn).genre = fem
    '    End If
    '  Case fem
    '    If GN(ng).genre = cindef Then
    '      GN(ng).genre = fem
    '    End If
    '  Case masc
    '    GN(ng).genre = masc
    'End Select}
      end;
  {si nom.genre=cindef : =GN.genre
  'idem avec pers }

{ PB un seul det, adj, nom par GN : trouver le moyen de faire
'une liste chaine : premier dans GN, x suivant dans x(det,nom,adj...) }

  end;

procedure lierGN_vb(mot1,mot2:Integer); {  utiliser }
  var
    ng,nv:integer;
    tmp:integer;

  begin
  { conflits :
    GN impose genre et nombre au verbe
    if pos[mot1].typ=cverbe then       }
      begin
        tmp:=mot1;
        mot1:=mot2;         { mot1 : cGN }
        mot2:=tmp;          { mot2 : cverbe }
      end;
    ng:=pos[mot1].mot;
    nv:=pos[mot2].mot;
    case GN[ng].fonct of
      csujet:verbe[nv].sujet:=ng;  { vrifier qu'il n'y en ait pas dj un }
      ccpt:verbe[nv].cpt:=ng;  { vrifier qu'il n'y en ait pas dj un }
    { sinon, demander la fonction (sujet/COD en particulier) ?  }
    { rajouter une rubrique 'fonction' au menu droulant ? }
    end;
    if GN[ng].prep<>aucun then  { forcment un cpt }
      verbe[nv].cpt:=ng;  { vrifier qu'il n'y en ait pas dj un }
    if (GN[ng].noyau<>aucun) and (nom[GN[ng].noyau].genre=masc) then
      verbe[nv].genre:=masc;
    { mme chose pour le nombre mais impossible de le stocker proprement (pers) }

  {si non li :
    'mot=mot1
    'noyau=cverbe (ou n verbe)
  'si GN est sujet :
    'si pers singulier :
        'det.pers = sing  (si existe)
        'adj.pers=sing      (")
        'nom.pers=sing      (")}
  end;

procedure liervb_adj(mot1,mot2:Integer);   { liermots }
  var
    nv,na:Integer;

  begin
    nv:=pos[mot1].mot;
    na:=pos[mot2].mot;
    If adj[na].fonct=cindef Then
      Case GN[adj[na].GN].fonct of
        csujet:adj[na].fonct:=attsuj;
        ccod:adj[na].fonct:=attcod;
      end;
    If verbe[nv].cpt=cindef Then  { utile ? }
      If (adj[na].fonct=attsuj) Or (adj[na].fonct=attcod) Then
    { necessit de crer un GN ou interdire et faire  la cration du GN }
        verbe[nv].cpt:=adj[na].GN;
    { sinon, ajouter  une liste ? }

{SSI c'est le sujet}
    If verbe[nv].pers<>cindef Then
    { vrifier si le nom n'est pas dj li  un verbe diffrent }
      If verbe[nv].pers<=3 Then   { SSI c'est le sujet }
        adj[na].nombre:=sing      { tait det[nd] : erreur ? }
      Else
        adj[na].nombre:=pluriel;  { pas certain si plusieurs noms }
  end;

procedure liervb_adv(mot1,mot2:Integer); { liermots }
  var
    nv,na:Integer;

  begin
    nv:=pos[mot1].mot;
    na:=pos[mot2].mot;
    adv[na].mode:=mot1;    { erreur si dj li ? }
    If verbe[nv].cpt=cindef Then  { utile ? }
      If (adv[na].mode=cverbe) Then
    { necessit de crer un GN ou interdire et faire  la cration du GN }
        verbe[nv].cpt:=mot2;  { PB : n'est pas un GN }
    { sinon, ajouter  une liste ? }

  end;

procedure liervb_det(mot1,mot2:Integer); { liermots }
  var
    nv,nd:Integer;

  begin
{ transferer directement  lierGN_vb ? }
    nv:=pos[mot1].mot;
    nd:=pos[mot2].mot;
    If det[nd].nom<>cindef Then      { aucun ? }
      begin
    {tester si GN li  un mot si non :
        'gestion du lien avec un groupe
        'lierGN_vb ?
    'si oui :
        'annuler, changer ?
    'plus ajouter les infos de GN a det}
      end;  { le nom n'a rien a transfrer au verbe (hormis le nombre ?) }

{ SSI c'est le sujet }
    If verbe[nv].pers<>cindef Then
  { vrifier si le nom n'est pas dj li  un verbe diffrent }
      If verbe[nv].pers<=3 Then  { SSI c'est le sujet }
        det[nd].nombre:=sing
      Else
        det[nd].nombre:=pluriel  { pas certain si plusieurs noms }
  end;

procedure liervb_nom(mot1,mot2:Integer); { liermot }
  var
    nv,nn:Integer;

  begin
{ transferer directement  lierGN_vb ? }
    nv:=pos[mot1].mot;
    nn:=pos[mot2].mot;
    If nom[nn].GN<>cindef Then
      begin
  {gestion du lien avec un groupe
  'lierGN_vb ?}
      end;   { le nom n'a rien a transfrer au verbe (hormis le nombre ?) }

{ 'reconnaitre s'il s'agit du sujet ou d'un complment }
    If verbe[nv].pers<>cindef Then
  { vrifier si le nom n'est pas dj li  un verbe diffrent }
      If verbe[nv].pers<=3 Then   { SSI c'est le sujet }
        nom[nn].nombre:=sing
      Else
        nom[nn].nombre:=pluriel;  { pas certain si plusieurs noms }
  end;

procedure liervb_prep(mot1,mot2:Integer);  { liermot }
  begin
  { si non dj li :
    'si li  GN :
        'GN=cpt}
  end;

procedure liermots(mot1,mot2:Integer);  { inutilis pour l'instant }
  var
    tmp:integer;
{'pour grer les symtries 1/2 et 2/1, on peut ordonner mot1 et mot2
'dans l'ordre croissant, hormis si l'ordre de slection importe

'penser que tous les paramtres ne sont pas obligatoirement renseigns
'ces routines seront appeles en cas de modification, donc la gestion
'des liens antrieurs doit en tenir compte.}

  begin
    If mot2>mot1 Then
      begin
        tmp:=mot2;
        mot2:=mot1;
        mot1:=tmp;
      end;
    Case pos[mot1].typ of
      cgn:Case mot2 of
            cverbe:lierGN_vb(mot1,mot2);
          end;
      cverbe:Case mot2 of
               cnom:liervb_nom(mot1,mot2);
               cadj:liervb_adj(mot1,mot2);
               cadv:liervb_adv(mot1,mot2);
               cdet:liervb_det(mot1,mot2);
               cprep:liervb_prep(mot1,mot2);
             end;
    end;
  end;

procedure modifier_mot(mot:Integer);               { par modifier ou dblclic }
  var
    i:Integer;

  begin
    with form1.Edit1 do
      begin
        Left:=pos[mot].x1+2;
        Top:=pos[mot].y1+2;
        Text:=phrase[mot].mot;
  { il n'est pas possible ici de fixer la position du curseur (en bout de mot) }
         Visible:=True;
         SetFocus;
       end;
    modif:=True;
end;

procedure TForm1.ModifierClick(Sender: TObject);  { ok }
  begin
    modifier_mot(mot2);
  end;

procedure TForm1.nombreClick(Sender: TObject);   { ok }
  var
    no:Integer;

  begin
    nomot:=mot2;
    no:=pos[nomot].mot;
    Case pos[nomot].typ of
      cnom:nom[no].nombre:=Not(nom[no].nombre);
      cadj:adj[no].nombre:=Not(adj[no].nombre);
      cdet:det[no].nombre:=Not(det[no].nombre);
      cverbe,cdeg:boite_pers(nomot);
    end;
  end;

procedure saisiemot(typ:Integer);  { quand un menu 'nouveau' est cliqu }
  begin
  { interaction avec editchange lorsque le mot est mis dans edit.text : change
    la taille du contrle et dessine un cadre autour. }

    pos[nbmot].x1:=form1.Image1.Canvas.PenPos.X;  { x1 et y1 sont dfinitivement }
    pos[nbmot].y1:=form1.Image1.Canvas.PenPos.Y;  { fixs ici lors de la saisie }
    pos[nbmot].typ:=typ;
    with form1.Edit1 do
      begin
        Text:='';
        pos[nbmot].x2:=Width+pos[nbmot].x1+2;  { x2 et y2 seront fixs }
        pos[nbmot].y2:=Height+pos[nbmot].y1+2; { dans aff_mot }
        Left:=pos[nbmot].x1+1;
        Top:=pos[nbmot].y1+1;
        Visible:=True;
      end;
    form1.Image1.Canvas.pen.Mode:=pmnot;
    If typ=cgn Then                                       { couleur !!!! }
    { crer une zone "bord" puis un nx nom }
      begin
        pos[nbmot].x2:=pos[nbmot].x2+8;
        pos[nbmot].y2:=pos[nbmot].y2+8;
        with form1.Edit1 do
          begin
            Left:=Left+4;
            Top:=Top+4;
          end;
        with pos[nbmot] do
          begin
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-2,y2-y1-2,false,1,clblue);
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-8,y2-y1-8,false,1,clblue);
          end;
      end;
    with pos[nbmot] do
      rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
    form1.Edit1.SetFocus;
    saisie:=True;
    form1.fichier.Enabled:=False;
    form1.nxmot.Enabled:=False;
  { pour viter le saut de focus, rendre indisponible les autres composants ? }
  { suite dans Edit1.keypressed  puis validernxmot }
  end;

procedure TForm1.NxAdjClick(Sender: TObject);       { ok }
  begin
    saisiemot(cadj);
  end;

procedure TForm1.NxAdvClick(Sender: TObject);       { ok }
  begin
    saisiemot(cadv);
  end;

procedure TForm1.NxDegClick(Sender: TObject);       { ok }
  begin
    saisiemot(cdeg);
  end;

procedure TForm1.NxDetClick(Sender: TObject);        { ok }
  begin
    saisiemot(cdet);
  end;

procedure TForm1.NxGNClick(Sender: TObject);        { ok }
  begin
    saisiemot(cGN);
  end;

procedure TForm1.NxNomClick(Sender: TObject);       { ok }
  begin
    saisiemot(cnom);
  end;

procedure TForm1.NxPrepClick(Sender: TObject);      { ok }
  begin
    saisiemot(cprep);
  end;

procedure TForm1.NxVerbeClick(Sender: TObject);      { ok }
  begin
    saisiemot(cverbe);
  end;

procedure TForm1.Image1DblClick(Sender: TObject);    { ok }
  begin
    If mot2>=0 Then
      modifier_mot(mot2);
  end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);          { ok }
  begin
    droit:=False;
    mot1:=quellezone(x,y);

{ il faut rajouter une rubrique nbtyp afin de stocker le nb du mot
'ou avoir autant de mots que de zones, mme s'il s'agit de groupe }

{ grer le dplacement des lments par un DragDrop }

  {nm = pos(mot1).mot }
    If Button=mbright Then    { button droit : menu ou lien }
      begin
        droit:=True;
        hors:=False;
        If mot1<>aucun Then
          begin
            with image1.canvas.pen do
              begin
                Style:=psdot;
                Mode:=pmxor;       { ?? }
                Width:=1;
                color:=clblack;
              end;
            xm:=(pos[mot1].x1+pos[mot1].x2) div 2;
            ym:=(pos[mot1].y1+pos[mot1].y2) div 2;
            xo:=x;
            yo:=y;
          end
      end
    Else
      If mot1<>aucun Then        { autre (hyp:gauche) dplacer }
        begin
          with image1.canvas.pen do
            begin
              Style:=pssolid;
              Mode:=pmnot;
              Width:=1;
            end;
          pos[nbmot].x1:=pos[mot1].x1;
          pos[nbmot].y1:=pos[mot1].y1;
          pos[nbmot].x2:=pos[mot1].x2;
          pos[nbmot].y2:=pos[mot1].y2;
          xo:=x;
          yo:=y;
       { utiliser la couleur et la forme de l'lment }
          with pos[nbmot] do
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblack);
        end;
  end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);                                  { ok }
  begin
    If mot1<>aucun Then
      If droit=True Then          { menu ou lien }
        If (x<pos[mot1].x1) Or (x>pos[mot1].x2) Or (y<pos[mot1].y1) Or (y>pos[mot1].y2) Then
          begin                    {  l'extrieur de la zone rserve au mot }
            with image1.canvas do
              begin
                moveto(xm,ym);
                lineto(xo,yo);
                moveto(xm,ym);
                lineto(x,y);
              end;
            xo:=x;
            yo:=y;
            hors:=True;
          end
        Else                      {  l'intrieur de la zone rserve au mot }
          begin
            xo:=x;
            yo:=y;
            If hors Then
              with image1.canvas do
                begin
                  moveto(xm,ym);
                  lineto(xo,yo);
                end;
          end
      Else { gauche : dplacer }
        begin
          with pos[nbmot] do         { utiliser la couleur de l'lment }
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblack);
          xo:=x-xo;
          yo:=y-yo;
          with pos[nbmot] do
            begin
              x1:=x1+xo;
              y1:=y1+yo;
              x2:=x2+xo;
              y2:=y2+yo;
            end;
          with pos[nbmot] do
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblack);
          xo:=x;
          yo:=y;
        end;
  end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);     { ok }
  var
    p:Tpoint;

  begin
    mot2:=quellezone(x, y);
  {'nm2 = pos(mot2).mot
'  nm1 = pos(mot1).mot}
    If (droit = True) Then     { menu ou lien }
      If (mot2 = mot1) Then    { click droit sur un mot : afficher le menu }
        begin
          If hors = False Then { ?! comment pourrait-il tre hors et dedans }
            begin              { (mot1=mot2)  la fois ?? }
              p.x:=x;
              p.y:=y;
              p:=image1.ClientToScreen(p);
              aff_menu(mot1,p.x,p.y)
            end
        end
      Else                     { lien entre deux lments }
        begin
          if mot1<>aucun then   { origine sur un lment }
            with image1.canvas do
              begin
                moveto(xm,ym);
                lineto(xo,yo);
                brush.Color:=clwhite;
              end;
{ afficher le second mot en surbrillance puis normalement pour montrer la connection}
          If (mot2<>aucun) And (mot1<>aucun) Then
            with image1.canvas do
              begin
                xo:=(pos[mot2].x1+pos[mot2].x2) div 2;
                yo:=(pos[mot2].y1+pos[mot2].y2) div 2;
                moveto(xm,ym);
                lineto(xo,yo);
                brush.Style:=bssolid;
                pen.Mode:=pmcopy;
                pen.Width:=1;
                aff_mot(mot2);
                aff_mot(mot1);
            { lier les mots }
              end;
        End
    Else                       { dplacement }
      If mot1<>aucun Then
        begin
          with pos[nbmot] do
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
          change_pos(mot1);    { change la position et raffiche les lments }
        end;
    mot1:=aucun;  { blocage de picture1.move }
  end;

procedure TForm1.ModeClick(Sender: TObject);      { ok }
  begin
    nomot:=mot2;
    boite_mode(pos[nomot].mot);
  end;

procedure TForm1.ppTempsClick(Sender: TObject);     { ok }
  begin
    nomot:=mot2;
    boite_temps(pos[nomot].mot);
  end;

procedure TForm1.Edit1Change(Sender: TObject);      { ok }
  begin
  { reste un pb si la saisie se fait sur le bord droit de l'image }
    If enaction=False Then
      begin
        enaction:=True;
        form1.Image1.Canvas.pen.Mode:=pmnot;
        if saisie then
          begin
            If pos[nbmot].typ=cgn Then
    { effacer la zone "bord" et celle du nom }
              with pos[nbmot] do
                begin
                  rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-2,y2-y1-2,false,1,clblue);
                  rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-8,y2-y1-8,false,1,clblue);
                end;
            with pos[nbmot] do
              rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
          end;
        Label0.Caption:=Edit1.Text;
        Edit1.Width:=Label0.Width+15;
     {   Edit1.Text:=Label0.Caption;}
    { afficher les nouvelles zones }
        if saisie then
          begin
            pos[nbmot].x2:=pos[nbmot].x1+Edit1.Width+2;
            pos[nbmot].y2:=pos[nbmot].y1+Edit1.Height+2;
            If pos[nbmot].typ=cgn Then
              begin
                pos[nbmot].x2:=pos[nbmot].x2+8;
                pos[nbmot].y2:=pos[nbmot].y2+8;
                with pos[nbmot] do
                  begin
                    rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-2,y2-y1-2,false,1,clblue);
                    rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-8,y2-y1-8,false,1,clblue);
                  end;
              end;
            with pos[nbmot] do
              rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
          end;
        enaction:=False;
      end;
  end;

procedure validernxmot;            { un mot a t saisi ou modifi }
  begin
    If typ=cgn Then
      with pos[nbmot] do
        begin
          rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-2,y2-y1-2,false,1,clblue);
          rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-8,y2-y1-8,false,1,clblue);
        end;
    with pos[nbmot] do
      rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
    form1.Image1.Canvas.pen.Mode:=pmcopy;
    Case pos[nbmot].typ of
      cnom:initnom(aucun);  { cas GN inconnu }
      cverbe:initverbe(aucun);    { cas prop inconnu }
      cdet:initdet(aucun);        { cas GN inconnu }
      cadj:initadj(aucun);       { cas GN inconnu }
      cadv:initadv(aucun);       { cas nom/GN inconnu }
      cprep:initprep(aucun);     { cas GN inconnu }
      cgn:initGN(aucun);         { cas GN/? inconnu }
      cdeg:initdeg(aucun);       { cas adj inconnu }
    end;
  end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);   { ok }
  begin
     If key=#13 Then
       begin
         saisie:=False;
         fichier.Enabled:=True;
         nxmot.Enabled:=True;
         Edit1.Visible:=False;
         If modif=False Then
           validernxmot        { c'est un nouvel lment }
         Else
           begin               { modification d'un lment existant }
             phrase[mot2].mot:=Edit1.Text;  { est ce la seule mention de nom ? }
             aff_mot(mot2);
             modif:=False;
           end;
         end
       Else
         If key=#27 Then
           begin
             saisie:=False;
             fichier.Enabled:=True;    { menus  nouveau accessibles }
             nxmot.Enabled:=True;
             Edit1.Visible:=False;
             modif:=False; { au cas ou une modif est annule }
           end;
   end;

procedure TForm1.Edit1Exit(Sender: TObject);          { ok }
  begin
    If saisie=True Then
      Edit1.SetFocus
  end;

end.
