unit Unit2;


{ cette unit serait bien affiche comme une liste surgissante prsentant les
  choix disponibles pour chaque mot :
    verbe : temps
    groupe nominal : nom/pronom
    article : dfini/indfini, singulier/pluriel
    prposition : proprit, lieu, manire, temps, ...
    ...

  La plupart des autres proprits se dduiront des autres mots (article donne
  genre et nombre du nom dsign, qualificatif et verbe l'obtiennent du nom, ...)

  il faut aussi penser  la faon de saisir le mot. Fenetre ou StaticText ->
  EditText + onexit (focus) ? }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ActnList, ExtCtrls;

const
{ constantes de type d'lment }
  CGV=1;             { groupe verbal }
  CGN=3;
  cverbe=256;
  Cnom=2*256;
  Cdet=3*256;
  Cadj=4*256;
  Cdeg=5*256;
  Cadv=6*256;
  Cprep=7*256;
  Cpnom=8*256;
  Tcpl=7;

  cindef=0;           { valeur non dfinie}
  aucun=$FFFF;        { pointeur nul }
  sing=True;          { singulier }
  pluriel=False;      { pluriel }
  neutre=3;           { neutre   seulement dans a_babel }
  fem=1;              {  " idem }
  masc=2;             {  " idem }
  attsuj=1;
  attcod=2;
  csujet=1;
  ccod=2;
  ccpt=3;
{ constantes dcrivant le menu droulant }
  cmodifier=1;
  cgenre=2;
  cnombre=4;
  ctemps=8;
  cmode=16;
  cmnnom=32;
  cmndet=64;
  cmnadj=128;
  cmnprep=512;
  cmnGN=1024;
  cajGN=2048;
  cajverbe=4096;
  cajadj=8192;
  cajadv=16384;
  cajcomp=32768;
  cajdet=65536;
  cajnom=131072;
  cajprep=262144;
{ constantes de mode verbal }
  cind=1;               { indicatif }
  ccond=2;              { conditionnel }
  csub=3;               { subjonctif }
  cimp=4;               { impratif }
  cinf=5;               { infinitif }
  cpart=6;              { participe }
{ constantes de temps }
  cpresent=1;           { prsent }
  cpasse=2;             { pass (simple) }
  cfutur=4;             { futur }
  cimparfait=8;         { imparfait }
  cpascomp=16;          { pass compos }
  cpasant=32;           { pass antrieur }
  cfutant=64;           { futur antrieur }
  cpqp=128;             { plus-que-parfait }
  cpasse2=256;          { pass type 2 }


type
  TForm2 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  PTexp=^Texpression;
  Texpression= record    { plus utilis : pour les ides }
                 mot:string;
                 typ:word; {ou char}
                 mode,temps,pers,ruc,aspect:byte;   { no ou champ de bits }
                 modi:word;            { chp de bits : ngation, rflchi, ...}
                 pluriel,genre:boolean;      { ou deux octets <=> temps }
                 qualifie,qualifiant:PTexp;     { expression qualifie }
                 suivant:PTexp;
               end;
  Tmot= record
          mot:String;
          cat:word;
          lien:word;
          niv:byte;     {niveau ds la rprsentation en cercle}
          l,h:integer;     { dimensions du mot }
          suite:integer;   { lien sur le mot suivant li au mme noyau }
        end;
  Tcommun= record
             mot:String [50];
             genre:byte;
             nombre:boolean;
             etat:Integer;       {lu/parcouru/li/accord/...}
           end;
  Tverbe= record
            mot:word;           {lien sur la liste de mots}
            cat:word;           {catgorie de mot}
            temps:word;         {verbe}
            aspect:word;        {verbe}
            mode:word;          {verbe}
            pers:byte;          {personne (nombre ?)}
            typ:word;           {in/trans., rfl. ...}
            neg:word;           {lien vers mot ngatif}
            etat:boolean;       {indicateur}
            passif:boolean;     { "        }
            copule:word;        {lien vers le qualifi}
            sujet:word;         {lien}
            cpt:word;           {lien sur premier cpt}
            genre:integer;
          end;
  Tsujet= record
            mot:word;             {lien sur la liste de mots}
            verbe:word;           {lien}
            typ:word;             {nom, pronom, infinif/verbe, prop)}
            inv:boolean;          {indicateur}
            genre:byte;           {commun}
            nombre:boolean;          {commun}
            GN:word;              {lien}
          end;
  Tnom= record
          mot:word;               {lien sur la liste de mots}
          genre:byte;             {commun}
          nombre:boolean;            {commun}
          det:word;               {lien}
          adj:word;               {lien (utile ? -> GN)}
          cpt:word;               {lien}
          cat:word;               {propre/commun,anim/inanim, ...)}
          GN:word;                {lien}
          suite:integer;
        end;
  Tdet= record
          mot:word;              {lien sur la liste de mots}
          genre:byte;
          nombre:boolean;
          typ:word;              {def,art/adj ind,cont,part,pos,dmon,...)}
          poss:Integer;          { ?? }
          neg:boolean;           { ?? }
          ens:boolean;           {art/poss/dm ou adj/n.card/int/excl}
          def:boolean;           {oui/non}
          nom:word;              {lien}
        end;
  Tadj= record
          mot:word;             {lien sur la liste de mots}
          fonct:byte;           {att sujet, att cod, pithte, appos}
          genre:byte;
          nombre:boolean;
          typ:word;             {qual, verb, p.pass, compos,inv...}
          cpl:word;             {lien sur ??}
          nom:word;             {lien (qualifi)(pronom)}
          GN:word;              {lien (utile ?! : nom -> gn )}
          degre:word;           {lien sur comparatif/sup.}
          accord:boolean;       {oui/non (ds genre+nombre ??)}
        end;
  Tdegre= record
            mot:word;             {lien sur la liste de mots}
            adj:word;             {lien}
            typ:byte;             {comp/sup rel, et sup/inf/gal}
            comp:word;            {lien sur le comparant (gn,adj,...)}
            place:boolean;        {ap/av ??}
            sup:word;             {lien vers sup irrgulier ?}
          end;
  Tadv= record
          mot:word;             {lien sur la liste de mots}
          mode:word;            {lien (ou verbe/adj/phrase/adv)}
          renvoi:boolean;       {oui/non}
          cat:word;             {manire,quantit,tps,lieu,aff,ng,doute)}
        end;
  TGN= record
         mot:word;             {lien sur la liste de mots}
         noyau:word;           {lien vers nom/verbe}
         det:word;             {lien}
         adj:word;             {lien (premier, table ?)}
         prep:word;            { lien vers la prposition (optionnel) }
         cpt:word;             {lien (" " ")}
         prop:word;            {lien}
         fonct:byte;           {sujet/cpl/CN}
         suiv:word;            {GN suivant coordonn}
       end;
  Tprep= record
           mot:word;
           fonct:word;            {type de cpl. circ.}
           des:word;              {le mot auquel se rapporte le cpl}
           lie:word;              {le mot qualifiant}
           sens:word;             {~ fonction}
           loc:boolean;           {mot simple/locution prp}
         end;

var
  Form2: TForm2;
  typ:word;
  saisiecorrecte:boolean;
  nomot:word;
  nbmot,nbverbe,nbnom,nbpronom,nbadv:word;
  nbsujet,nbdet,nbadj,nbdeg,nbprep:word;
  nbGN:word;
  selection:Integer;
  sujet:array of Tsujet;       { array simple sans [] }
  GN:array of TGN;
  phrase:array of Tmot;
  verbe:array of Tverbe;
  det:array of Tdet;
  nom:array of Tnom;
  adj:array of Tadj;
  deg:array of Tdegre;
  adv:array of Tadv;
  prep:array of Tprep;
  xm,ym:Integer;
  lg:array[0..6] of integer;     {largeur des niveaux : inutilis}

procedure rectangle(xm,ym,l,h:Integer;biseau:boolean;mine:Integer;coul:Tcolor);

procedure ellipse(xm,ym,l,h:Integer;mine:Integer;coul:Tcolor);

procedure boite_genre(no,typ:Integer);

procedure boite_mode(no:Integer);

procedure boite_pers(no:Integer);

procedure boite_temps(no:Integer);

procedure initadj(lienGN:Integer);

procedure initadv(lien:Integer);

procedure initdeg(lien:Integer);

procedure initdet(lienGN:Integer);

procedure initGN(lienGN:Integer);

procedure initnom(lienGN:Integer);

procedure initprep(lienGN:Integer);

procedure initverbe(lienprop:Integer);

implementation

uses Unit1;

{$R *.DFM}
const
  boolvsoct:array[false..true] of integer =(0,1);

var
  i:integer;

procedure TForm2.FormCreate(Sender: TObject);
  begin               { ici ou dans form2 ? }
    nbGN:=0;
    nbnom:=0;
    nbsujet:=0;
    nbverbe:=0;
    nbmot:=0;
    nbdet:=0;
    nbadj:=0;
    nbdeg:=0;
    nbprep:=0;
  end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
  begin
    form1.enabled:=true;  { ncessaire s'il est ferm en cour de saisie }
  end;

procedure TForm2.Button2Click(Sender: TObject); { ok }
  begin
    hide;
  end;

procedure rectangle(xm,ym,l,h:Integer;biseau:boolean;mine:Integer;coul:Tcolor);
  var              { par u1 ok }
    pts:array of Tpoint;        { pour d'autre formes (biseaut, arrondi ...) }

  begin
    form1.Image1.Canvas.pen.Width:=mine;
      form1.Image1.Canvas.pen.Color:=coul;
    If not(biseau) Then
      begin
        with form1.Image1.Canvas do
          begin
            moveto(xm-l div 2,ym-h div 2);
            lineto(xm+l div 2,ym-h div 2);
            lineto(xm+l div 2,ym+h div 2);
            lineto(xm-l div 2,ym+h div 2);
            lineto(xm-l div 2,ym-h div 2);
          end;
      end;
  end;

procedure ellipse(xm,ym,l,h:Integer;mine:Integer;coul:Tcolor);
  begin          { par u1 ok }
    with form1.Image1.Canvas do
      begin
        Pen.Width:=mine;
        Brush.Style:=bssolid;
        Brush.Color:=clwhite;
        pen.Color:=coul;
        Ellipse(xm-l div 2,ym-h div 2,xm+l div 2,ym+h div 2);
        Brush.Style:=bssolid;
        Brush.Color:=clwhite;
      end;
  end;

procedure boite_genre(no,typ:Integer);         { par u1 }
  begin
    case typ of
      cnom:form2.Caption:='Genre du nom';
      cadj:form2.Caption:='Genre de l''adjectif';
      cdet:form2.Caption:='Genre du dterminant';
      cverbe:form2.Caption:='Genre de la personne du verbe';
    end;
    with form2.Combobox1 do
      begin
        Clear;
        Items.Add('inconnu');   { ou autre }
        Items.Add('fminin');
        Items.Add('masculin');
        Items.Add('neutre');
      end;
    form2.label1.Caption:='Genre';
    form2.Show;
  { amliorer en prslectionnant le mode courant du verbe }
    form2.Combobox1.ItemIndex:=0;
    selection:=2;
  end;

procedure boite_mode(no:Integer);          { par u1 }
  begin
    with form2.Combobox1 do
      begin
        Clear;
        Items.Add('aucun');   { ou autre }
        Case verbe[no].temps of
          cpresent,cpasse,cindef:
            begin
              Items.Add('indicatif');
              Items.Add('subjonctif');
              Items.Add('conditionnel');
              Items.Add('impratif');
              Items.Add('indicatif');
              Items.Add('participe');
            end;
          cimparfait,cpqp:
            begin
              Items.Add('indicatif');
              Items.Add('subjonctif');
            end;
          cpasse2:Items.Add('conditionnel');
          Else
            Items.Add('indicatif');
        end;
      end;
    form2.label1.Caption:='Mode';
    form2.Caption:='Verbe';
    form2.Show;
  { amliorer en prslectionnant le mode initial du verbe }
    form2.ComboBox1.ItemIndex:=0;
    selection:=1;
  end;

procedure boite_pers(no:Integer);  { par u1 }
  begin
    with form2.Combobox1 do
      begin
        Clear;
        If pos[no].typ=cverbe Then
          begin
            Items.Add('inconnu');   { ou autre }
            Items.Add('1er sing');  { ou autre }
            Items.Add('2me sing');
            Items.Add('3me sing');
            Items.Add('1er plur');
            Items.Add('2me plur');
            Items.Add('3me plur');
            form2.label1.Caption:='Personne';
          end
        else
          begin
            Items.Add('inconnu');   { ou autre  }
            Items.Add('Comp sup');  { ou autre }
            Items.Add('Comp inf');
            Items.Add('Comp ga');
            Items.Add('Sup rel');
            Items.Add('Sup abs');
            form2.label1.Caption:='Type';
          end;
      end;
    form2.Caption:='Verbe'; { il y auta aussi les adjectifs possessifs }
    form2.Show;
  { amliorer en prslectionnant le mode initial du verbe }
    form2.ComboBox1.ItemIndex:=0;
    selection:=3;
  end;

procedure boite_temps(no:Integer);    { par u1 }
  begin
    with form2.Combobox1 do
      begin
        Clear;
        Items.Add('aucun');
        Case verbe[no].mode of
          cind,cindef:
            begin
              Items.Add('prsent');
              Items.Add('pass simple');
              Items.Add('imparfait');
              Items.Add('plus-que-parfait');
              Items.Add('futur');
              Items.Add('pass compos');
              Items.Add('futur antrieur');
              Items.Add('pass antrieur');
            end;
          ccond:
            begin
              Items.Add('prsent');
              Items.Add('pass 1');
              Items.Add('pass 2');
            end;
          csub:
            begin
              Items.Add('prsent');
              Items.Add('pass');
              Items.Add('imparfait');
              Items.Add('plus-que-parfait');
            end;
          cimp,cinf,cpart:
            begin
              Items.Add('prsent');
              Items.Add('pass');
            end;
        end;
        If verbe[no].mode=cindef Then
          Items.Add('pass 2');
      end;
    form2.label1.Caption:='Temps';
    form2.Caption:='Verbe';
    form2.Show;
    { amliorer en prslectionnant le temps initial du verbe }
    form2.ComboBox1.ItemIndex:=0;
    selection:=0;
  end;

procedure valideadj(no:Integer);       { par valider }
  var
    nv:Integer;
  { RESTE : cat GN   }

  begin
    nv:=pos[nomot].mot;
    Case no  of      { no est gal  la constante affecte }
      0:adj[nv].genre:=cindef;
      1:adj[nv].genre:=fem;
      2:adj[nv].genre:=masc;
      3:adj[nv].genre:=neutre;
    end;
  end;

procedure validedeg(no:integer);         { par valider }
  var
    nv:integer;

{ RESTE : genre nombre }
  begin
    nv:=pos[nomot].mot;
    Case no of         { no est gal  la constante affecte }
      0:deg[nv].typ:=cindef;
      1:deg[nv].typ:=1;    { comp > }
      2:deg[nv].typ:=2;    { comp < }
      3:deg[nv].typ:=4;    { comp = }
      4:deg[nv].typ:=8;    { sup rel }
      5:deg[nv].typ:=16;   { sup abs }
    end;
  End;

procedure validedet(no:Integer);              { par valider }
{ RESTE : genre nombre }
  var
    nv:Integer;

  begin
    nv:=pos[nomot].mot;
    Case no of      { no est gal  la constante affecte }
      0:det[nv].genre:=cindef;
      1:det[nv].genre:=fem;
      2:det[nv].genre:=masc;
      3:det[nv].genre:=neutre;
    end;
  end;

procedure validenom(no:Integer);           { par valider }
  {RESTE : cat GN}
  var
    nv:Integer;

  begin
    nv:=pos[nomot].mot;
    Case no  of     {  no est gal  la constante affecte }
      0:nom[nv].genre:=cindef;
      1:nom[nv].genre:=fem;
      2:nom[nv].genre:=masc;
      3:nom[nv].genre:=neutre;
    end;
  end;

procedure valideverbe(no:Integer);              { par valider }
  var
    nv:Integer;

  begin
    nv:=pos[nomot].mot;
    Case selection of
      1:Case no of
          0:verbe[nv].mode:=cindef;
          1:If verbe[nv].temps<>cpasse2 Then
              verbe[nv].mode:=cind
            Else
              verbe[nv].mode:=ccond;
          2:verbe[nv].mode:=csub;
          3:verbe[nv].mode:=ccond;
          4:verbe[nv].mode:=cimp;
          5:verbe[nv].mode:=cinf;
          6:verbe[nv].mode:=cpart;
        end;
      0:Case no of
          0:verbe[nv].temps:=cindef;
          1:verbe[nv].temps:=cpresent;
          2:verbe[nv].temps:=cpasse;
          3:If verbe[nv].mode<>ccond Then
              verbe[nv].temps:=cimparfait
            Else
              verbe[nv].temps:=cpasse2;
          4:verbe[nv].temps:=cpqp;
          5:verbe[nv].temps:=cfutur;
          6:verbe[nv].temps:=cpascomp;
          7:verbe[nv].temps:=cfutant;
          8:verbe[nv].temps:=cpasant;
          9:verbe[nv].temps:=cpasse2;  { cindef }
        end;
      2:Case no of      { no est gal  la constante affecte }
          0:verbe[nv].genre:=cindef;
          1:verbe[nv].genre:=fem;
          2:verbe[nv].genre:=masc;
          3:verbe[nv].genre:=neutre;
        end;
      3:Case no of
          0:verbe[nv].pers:=cindef;
          1:verbe[nv].pers:=1;
          2:verbe[nv].pers:=2;
          3:verbe[nv].pers:=4;
          4:verbe[nv].pers:=8;
          5:verbe[nv].pers:=16;
          6:verbe[nv].pers:=32;
        end;
    end;
  end;

procedure valider(no:integer);    { par boutton1clic }
  begin
    Case pos[nomot].typ of
      cverbe:valideverbe(no);
      cnom:validenom(no);
      cdet:validedet(no);
      cadj:valideadj(no);
      cdeg:validedeg(no);
 { les autre lments (prposition, adverbe, GN) n'ont aucun paramtre  fixer }
    end;
  end;

procedure TForm2.Button1Click(Sender: TObject); { ok }
  var
    index:Integer;

  begin
    index:=form2.ComboBox1.ItemIndex;
    valider(index);
    hide;
  end;

procedure initadj(lienGN:Integer);  { appel par u1 }
  begin
    adj[nbadj].mot:=nbmot;
    pos[nbmot].mot:=nbadj;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    adj[nbadj].nom:=lienGN;   { pour l'instant, nom. gnraliser plus tard  GN }
    If lienGN<>aucun Then
    { 'rechercher les liens des det, adj et cpt, voire le genre et }
    { le nombre }
    Else
      begin
        adj[nbadj].genre:=cindef;   { nom }
        adj[nbadj].nombre:=sing;  {cindef;  }{ nom }
        adj[nbadj].typ:=cindef;     { place/infos }
        adj[nbadj].degre:=aucun;
        adj[nbadj].accord:=false; {cindef;}  { dico/aide }
        adj[nbadj].fonct:=cindef;   { place/aide }
        adj[nbadj].cpl:=aucun;      { ? }
        adj[nbadj].GN:=aucun     {? }
      end;
    nbadj:=nbadj+1;
    nbmot:=nbmot+1;
    setlength(adj,nbadj+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=1;          { couleur de nom, ou bleu par dfaut }
    mine:=2;
    style:=pssolid;
    aff_mot(nbmot-1);
  end;

procedure initadv(lien:Integer);         { par u1 }
  begin
    adv[nbadv].mot:=nbmot;
    pos[nbmot].mot:=nbadv;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    adv[nbadv].mode:=lien;   { pour l'instant, nom. gnraliser plus tard  GN }
    adv[nbadv].renvoi:=false; {cindef;}    { nom }
    adv[nbadv].cat:=cindef;   { nom }
    nbadv:=nbadv+1;
    nbmot:=nbmot+1;
    setlength(adv,nbadv+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=13;          { couleur de nom, ou bleu par dfaut }
    mine:=2;
    style:=psdot;
    aff_mot(nbmot-1);
  end;

procedure initdeg(lien:Integer);    { par u1 }
  begin
    deg[nbdeg].mot:=nbmot;
    pos[nbmot].mot:=nbdeg;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    deg[nbdeg].adj:=lien;
    If lien<>aucun Then
    { rechercher les liens des det, adj et cpt, voire le genre et
      le nombre }
    Else
      begin
        deg[nbdeg].typ:=cindef;
        deg[nbdeg].comp:=aucun;
        deg[nbdeg].place:=False;  { non appos }
        deg[nbdeg].sup:=aucun;
      end;
    nbdeg:=nbdeg+1;
    nbmot:=nbmot+1;
    setlength(deg,nbdeg+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=1;          { nature du nom (sujet/cpt) }
    mine:=2;
    style:=pssolid;
    aff_mot(nbmot-1);
  end;

procedure initdet(lienGN:Integer);       { par u1 }
  begin
    det[nbdet].mot:=nbmot;
    pos[nbmot].mot:=nbdet;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    det[nbdet].nom:=lienGN;   { pour l'instant, nom. gnraliser plus tard  GN }
    If lienGN<>aucun Then
    { rechercher les liens des det, adj et cpt, voire le genre et
      le nombre }
    Else
      begin
        det[nbdet].genre:=cindef;
        det[nbdet].nombre:=sing; {cindef;}
        det[nbdet].typ:=cindef;    { dico }
        det[nbdet].poss:=cindef;
        det[nbdet].neg:=false; {cindef;}
        det[nbdet].ens:=false; {cindef;}     { dico }
        det[nbdet].def:=false; {cindef;}     { dico }
      end;
    nbdet:=nbdet+1;
    nbmot:=nbmot+1;
    setlength(det,nbdet+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=1;          { couleur de nom, ou bleu par dfaut }
    mine:=2;
    style:=pssolid;
    aff_mot(nbmot-1);
  end;

procedure initGN(lienGN:Integer);     { par u1 }
  begin
    GN[nbGN].mot:=nbmot;         { nbnom ou nb GN ? }
    pos[nbmot].mot:=nbGN;
    form1.Label0.Caption:=form1.Edit1.Text;
    phrase[nbmot].l:=form1.Label0.Width+8;
    phrase[nbmot].h:=form1.Label0.Height+8;
    pos[nbmot].x2:=pos[nbmot].x1+phrase[nbmot].l+2;
    pos[nbmot].y2:=pos[nbmot].y1+phrase[nbmot].h+2;
    If lienGN=aucun Then
      begin
        GN[nbGN].mot:=nbmot;
        pos[nbmot].mot:=nbGN;
        {phrase[nbmot].mot:='';
        phrase[nbmot].cat:=pos[nbmot].typ;
        phrase[nbmot].lien:=pos[nbmot].mot;
        nom[nbnom].GN:=lienGN;}
        GN[nbGN].noyau:=aucun;  { type plutt que lien (dans mot) }
        GN[nbGN].det:=aucun;
        GN[nbGN].adj:=aucun;
        GN[nbGN].cpt:=aucun;
        GN[nbGN].prop:=aucun;
        GN[nbGN].fonct:=cindef;
        GN[nbGN].suiv:=aucun;
        GN[nbGN].prep:=aucun;
        with pos[nbmot] do
          begin
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1,y2-y1,false,1,clblue);
            rectangle((x1+x2) div 2,(y1+y2) div 2,x2-x1-2,y2-y1-2,false,1,clblue);
          end;
        nbGN:=nbGN+1;
        nbmot:=nbmot+1;
        setlength(GN,nbGN+1);
        setlength(phrase,nbmot+1);
        setlength(pos,nbmot+1);
      { crer une nx zone }
        pos[nbmot].x1:=pos[nbmot-1].x1+4;
        pos[nbmot].y1:=pos[nbmot-1].y1+4;
        pos[nbmot].x2:=form1.Edit1.Width+pos[nbmot].x1+1;
        pos[nbmot].y2:=form1.Edit1.Height+pos[nbmot].y1+1;
        pos[nbmot].typ:=cnom;
        GN[nbGN-1].noyau:=nbnom;  { type plutt que lien (dans mot) }
        initnom(nbGN-1);
      end
{    Else
    ' faire}
  end;

procedure initnom(lienGN:Integer);        { par u1; !!! attention dans initGN }
  begin
    nom[nbnom].mot:=nbmot;
    pos[nbmot].mot:=nbnom;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    nom[nbnom].GN:=lienGN;
    If lienGN<>aucun Then
    { rechercher les liens des det, adj et cpt, voire le genre et
    'le nombre }
      begin  { en attendant, valeur par dfaut }
{ remarque, la cration pourrait devoir tre traite diffremment de la liaison }
        nom[nbnom].genre:=cindef;
        nom[nbnom].nombre:=sing; {cindef;}
        nom[nbnom].det:=aucun;
        nom[nbnom].adj:=aucun;
        nom[nbnom].cpt:=aucun;
        nom[nbnom].cat:=cindef;   { cf dico }
      end
    Else
      begin
        nom[nbnom].genre:=cindef;
        nom[nbnom].nombre:=sing; {cindef;}
        nom[nbnom].det:=aucun;
        nom[nbnom].adj:=aucun;
        nom[nbnom].cpt:=aucun;
        nom[nbnom].cat:=cindef;   { cf dico }
      end;
    nbnom:=nbnom+1;
    nbmot:=nbmot+1;
    setlength(nom,nbnom+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=1;          { nature du nom (sujet/cpt) }
    mine:=2;
    style:=pssolid;
    aff_mot(nbmot-1);
  end;

procedure initprep(lienGN:Integer);      { par u1 }
  begin
    prep[nbprep].mot:=nbmot;
    pos[nbmot].mot:=nbprep;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    prep[nbprep].lie:=lienGN;   { pour l'instant, nom. gnraliser plus tard  GN }
    If lienGN<>aucun Then
    { rechercher les liens des det, adj et cpt, voire le genre et
    'le nombre }
    Else
      begin
        prep[nbprep].des:=aucun;   { GN/aide }
        prep[nbprep].fonct:=cindef; { GN/aide/dico }
        prep[nbprep].sens:=cindef;  { GN/aide/dico }
      end;
    prep[nbprep].loc:=false; {cindef;}   { dico/texte }
    nbprep:=nbprep+1;
    nbmot:=nbmot+1;
    setlength(prep,nbprep+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=1;          { couleur de nom, ou bleu par dfaut }
    mine:=2;
    style:=psdot;
    aff_mot(nbmot-1);
  end;

procedure initpronom;         { inutilis pour l'instant }
  begin
    form2.Caption:='Pronom';
{    form2.Label0.Caption:='mot';
    form2.Edit1.Text:='';
    form2.Label1.Caption:='Type';
    form2.ComboBox1.Clear;
    form2.ComboBox1.Items.Add('personnel');
    form2.ComboBox1.Items.Add('dmonstratif');
    form2.ComboBox1.Items.Add('possessif');
    form2.ComboBox1.Items.Add('interrogatif');
    form2.ComboBox1.ItemIndex:=0;
    form2.Label2.Caption:='Fonction/dsign';
    form2.ComboBox2.Clear;
    form2.ComboBox2.Items.Add('sujet');
    form2.ComboBox2.Items.Add('COD');
    form2.ComboBox2.Items.Add('COI');
    form2.ComboBox2.Items.Add('CC(L)');
    form2.ComboBox2.ItemIndex:=0;
    form2.Label5.Caption:='Personne';
    form2.ComboBox5.Clear;
    form2.ComboBox5.Items.Add('1re');
    form2.ComboBox5.Items.Add('2nd');
    form2.ComboBox5.Items.Add('3me');}
  {rien pour l'instant
  'form2.Combo5.ListIndex = 0}
 {   form2.Label3.Caption:='On/Compos';
    form2.ComboBox3.Clear;
    form2.ComboBox3.Items.Add('quelqu''un/');
    form2.ComboBox3.Items.Add('tous/ci');
    form2.ComboBox3.Items.Add('nous/l');
    form2.ComboBox3.Items.Add('tu');       }
  {rien pour l'instant}
 {   form2.Label4.Caption:='Genre';
    form2.ComboBox4.Clear;
    form2.ComboBox4.Items.Add('masculin');
    form2.ComboBox4.Items.Add('fminin');}
  {rien pour l'instant}
{    form2.RadioGroup1.Items.Clear;
    form2.RadioGroup1.Caption:='Type';
    form2.RadioGroup1.Items.Add('singulier');
    form2.RadioGroup1.Items.Add('neutre');
    form2.RadioGroup1.Items.Add('pluriel');
    form2.CheckBox1.Caption:='accent/simple/nbre';
    form2.CheckBox2.Caption:='formel/objet';
    form2.CheckBox3.Caption:='on/direct';
    form2.Label3.Visible:=True;
    form2.ComboBox3.Visible:=True;
    form2.Label4.Visible:=True;
    form2.ComboBox4.Visible:=True;
    form2.CheckBox1.Visible:=True;
    form2.CheckBox2.Visible:=True;
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    form2.CheckBox3.Visible:=True;}
  end;

procedure initverbe(lienprop:Integer);        { par u1 }
  begin
    verbe[nbverbe].mot:=nbmot;
    pos[nbmot].mot:=nbverbe;
    phrase[nbmot].mot:=form1.Edit1.Text;
    phrase[nbmot].cat:=pos[nbmot].typ;
    phrase[nbmot].lien:=pos[nbmot].mot;
    verbe[nbverbe].temps:=cindef;
    verbe[nbverbe].aspect:=cindef;
    verbe[nbverbe].mode:=cindef;
    verbe[nbverbe].pers:=cindef;
    verbe[nbverbe].typ:=cindef;
    verbe[nbverbe].neg:=aucun;
    verbe[nbverbe].etat:=false; {cindef;}
    verbe[nbverbe].passif:=false; {cindef;}
    verbe[nbverbe].copule:=aucun;
    verbe[nbverbe].sujet:=aucun;
    verbe[nbverbe].cpt:=aucun;
    nbverbe:=nbverbe+1;
    nbmot:=nbmot+1;
    setlength(verbe,nbverbe+1);
    setlength(phrase,nbmot+1);
    setlength(pos,nbmot+1);
    tour:=4;
    mine:=2;
    style:=pssolid;
    aff_mot(nbmot-1);
  end;

procedure TForm2.FormShow(Sender: TObject);   { attention : pas de editcombos }
  begin
    form1.enabled:=false;
  end;

procedure TForm2.FormHide(Sender: TObject);
  begin
    form1.enabled:=true; 
  end;

end.
